variables:
  _flow_deploy_src_validate: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/deploy/deploy_validate.sh"
  _flow_deploy_src_format: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/deploy/deploy_format.sh"
  _flow_deploy_src_lint: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/deploy/deploy_lint.sh"
  _flow_deploy_src_deploy: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/deploy/deploy.sh"
  _flow_deploy_src_deploy_inventory: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/deploy/deploy_inventory.py"
  _flow_deploy_img_validate: "alpine:latest"
  _flow_deploy_img_format: "python:alpine"
  _flow_deploy_img_lint: "python:alpine"
  _flow_deploy_img_deploy: "python:alpine"


validate deploy:
  stage: validate
  image: $_flow_deploy_img_validate
  dependencies: []
  before_script:
    - apk add wget
    - wget -q -O /usr/bin/flow-common "$_flow_common_sh_src"
    - wget -q -O /usr/bin/flow-deploy "$_flow_deploy_src_validate"
    - chmod +x /usr/bin/flow-deploy
  script:
    - /usr/bin/flow-deploy validate
  rules:
    - if: $CI_PIPELINE_SOURCE != 'merge_request_event'
      when: never
    - if: $_flow_deploy != "true"
      when: never
    - if: $_flow_deploy_validate != "true"
      when: never
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_prod_branch && $_flow_prod_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env1_branch && $_flow_env1_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env2_branch && $_flow_env2_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env3_branch && $_flow_env3_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env4_branch && $_flow_env4_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env5_branch && $_flow_env5_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env6_branch && $_flow_env6_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env7_branch && $_flow_env7_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env8_branch && $_flow_env8_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env9_branch && $_flow_env9_deploy == 'true'
  artifacts:
    name: "$CI_JOB_NAME_SLUG - $CI_COMMIT_SHORT_SHA on $CI_COMMIT_REF_SLUG"
    expire_in: 1 day
    public: false
    paths:
      - $_flow_reports_path
    reports:
      codequality: ${_flow_reports_path}/codequality/${_flow_report_deploy_validate}


format deploy:
  stage: validate
  image: $_flow_deploy_img_format
  dependencies: []
  before_script:
    - pip install --upgrade pip
    - pip install yamllint
    - wget -q -O /usr/bin/flow-common "$_flow_common_sh_src"
    - wget -q -O /usr/bin/flow-deploy "$_flow_deploy_src_format"
    - chmod +x /usr/bin/flow-deploy
  script:
    - /usr/bin/flow-deploy format
  rules:
    - if: $CI_PIPELINE_SOURCE != 'merge_request_event'
      when: never
    - if: $_flow_deploy != "true"
      when: never
    - if: $_flow_deploy_validate != "true"
      when: never
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_prod_branch && $_flow_prod_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env1_branch && $_flow_env1_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env2_branch && $_flow_env2_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env3_branch && $_flow_env3_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env4_branch && $_flow_env4_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env5_branch && $_flow_env5_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env6_branch && $_flow_env6_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env7_branch && $_flow_env7_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env8_branch && $_flow_env8_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env9_branch && $_flow_env9_deploy == 'true'
  artifacts:
    name: "$CI_JOB_NAME_SLUG - $CI_COMMIT_SHORT_SHA on $CI_COMMIT_REF_SLUG"
    expire_in: 1 day
    public: false
    paths:
      - $_flow_reports_path
    reports:
      codequality: ${_flow_reports_path}/codequality/${_flow_report_deploy_format}


lint deploy:
  stage: validate
  image: $_flow_deploy_img_lint
  dependencies: []
  before_script:
    - apk add gcc py3-cffi libffi-dev alpine-sdk
    - pip install --upgrade pip
    - pip install ansible-lint
    - wget -q -O /usr/bin/flow-deploy "$_flow_deploy_src_lint"
    - chmod +x /usr/bin/flow-deploy
  script:
    - /usr/bin/flow-deploy lint
  rules:
    - if: $CI_PIPELINE_SOURCE != 'merge_request_event'
      when: never
    - if: $_flow_deploy != "true"
      when: never
    - if: $_flow_deploy_validate != "true"
      when: never
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_prod_branch && $_flow_prod_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env1_branch && $_flow_env1_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env2_branch && $_flow_env2_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env3_branch && $_flow_env3_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env4_branch && $_flow_env4_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env5_branch && $_flow_env5_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env6_branch && $_flow_env6_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env7_branch && $_flow_env7_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env8_branch && $_flow_env8_deploy == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env9_branch && $_flow_env9_deploy == 'true'
  artifacts:
    name: "$CI_JOB_NAME_SLUG - $CI_COMMIT_SHORT_SHA on $CI_COMMIT_REF_SLUG"
    expire_in: 1 day
    public: false
    paths:
      - $_flow_reports_path
    reports:
      codequality: ${_flow_reports_path}/codequality/${_flow_report_deploy_lint}


deploy environment:
  stage: deploy
  image: $_flow_deploy_img_deploy
  before_script:
    - apk add gcc py3-cffi libffi-dev alpine-sdk openssh
    - pip install --upgrade pip
    - pip install ansible
    - wget -q -O /usr/bin/flow-deploy-inventory "$_flow_deploy_src_deploy_inventory"
    - chmod +x /usr/bin/flow-deploy-inventory
    - wget -q -O /usr/bin/flow-deploy "$_flow_deploy_src_deploy"
    - chmod +x /usr/bin/flow-deploy
  script:
    - /usr/bin/flow-deploy deploy
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
      when: never
    - if: $_flow_deploy != "true"
      when: never
    - if: $CI_COMMIT_BRANCH == $_flow_prod_branch && $_flow_prod_deploy == 'true' && $_flow_prod_deploy_manual != 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_prod_branch && $_flow_prod_deploy == 'true' && $_flow_prod_deploy_manual == 'true'
      when: manual
    - if: $CI_COMMIT_BRANCH == $_flow_env1_branch && $_flow_env1_deploy == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env2_deploy == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env3_branch && $_flow_env3_deploy == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env4_branch && $_flow_env4_deploy == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env5_branch && $_flow_env5_deploy == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env6_branch && $_flow_env6_deploy == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env7_branch && $_flow_env7_deploy == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env8_branch && $_flow_env8_deploy == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env9_branch && $_flow_env9_deploy == 'true'
